﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
//
using System.Data;
using System.Data.SqlClient;
using MySqlStuff;
using SimplifiedShippingSystem.Classes;
using SimplifiedShippingSystemClasses;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript.Web;


namespace SimplifiedShippingSystem.Orders
{
    public partial class XEditOrder : System.Web.UI.Page
    {
        public string clientID = "ECK";
        public string divID = "";
        public string userName = "";
        public string userID;
        public string orderID = "";
        protected OrderClass _order;
        public List<ListItem> ddClass, ddType, ddWEIGHT, ddDIM, ddReferenceTypes, ddAccLoc, ddAccType, ddContactType, ddCountry, ddStateUS, ddStateCA, ddStateMX, ddTimeZone;
        //public List<ListItem> ddLENGTH;
        //public List<ListItem> ddCUBE;

        protected void Page_Load(object sender, EventArgs e)
        {
            userID = Master.UserID.ToString();
            userName = "Andy";//Master.UserName;
            if (!IsPostBack)
            {
                Session["TermsTab"] = new TermsTabClass(clientID, divID, userID);
                Session["mode"] = Request.QueryString["Action"] != null ? Request.QueryString["Action"] : "EDIT";  //NEW or EDIT
                Session["id"] = orderID = Request.QueryString["ID"] != null ? Request.QueryString["ID"] : "37012179-199C-4368-85B1-13849439FF68";

                loadDropDowns();


                if (Session["mode"].ToString() != "NEW")
                    _order = new OrderClass(orderID);
                else
                    _order = new OrderClass();

                if (orderID != "")
                {
                    this.OrderIDHiddenField.Value = orderID;
                    this.MovementIDHiddenField.Value = _order.Movement.MovementID.ToString();
                }

                
                    //Load the page data
                    Order_to_ItemContent();
                    origin_to_ItemContent(_order.Movement.OrgAddress);
                    destination_to_ItemContent(_order.Movement.DesAddress);
                    Contacts_to_ItemContent(_order.ContactList);
                    LineItems_to_ItemContent(_order.LineItemList);
                    References_to_ItemContent(_order.ReferenceList);
                    Accessorials_to_ItemContent(_order.AccessorialList);
            }
            //else
            //    BindData();
        }

       private void BindData()
        {
            List<OrderContactClass> Contacts = Session["CDataSource"] as List<OrderContactClass>;
            Contacts_to_ItemContent(Contacts);

           List<OrderLineItemClass> ListItem = Session["LIDataSource"] as List<OrderLineItemClass>;
           LineItems_to_ItemContent(ListItem);

           List<OrderReferenceClass> References = Session["RDataSource"] as List<OrderReferenceClass>;
           References_to_ItemContent(References);

           List<OrderAccessorialClass> Accessorials = Session["ADataSource"] as List<OrderAccessorialClass>;
           Accessorials_to_ItemContent(Accessorials);
        }
       protected void saveOrder(object sender, EventArgs e)
        {
            string Result = "";

            Result += C_SaveData();
            Result += LI_SaveData();
            Result += R_SaveData();
            Result += A_SaveData();

            if (Result.Length > 1)
            {
                this.ReviewErrorLabel.Text = Result;
                this.ReviewLabel.Text = "Order Save failed";
            }
            else
                this.ReviewLabel.Text = "Order Save failed";
        }

        #region LoadPage
        private void loadDropDowns()
        {
            // TIME ZONES
            if (ddTimeZone == null)
                ddTimeZone = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.BOLGenerator))
            {
                try
                {
                    ddTimeZone.Add(new ListItem("", "Select..."));

                    conn.Open();
                    string selectStr = "SELECT DISTINCT TimeZone FROM blTimeZones ORDER BY TimeZone DESC";
                    SqlCommand cmd = new SqlCommand(selectStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    while (reader.Read())
                    {
                        int tz = reader.GetInt32(0);
                        ListItem i = new ListItem(tz == -4 ? "Atlantic" : tz == -5 ? "Eastern" : tz == -6 ? "Central" : tz == -7 ? "Mountain" : tz == -8 ? "Pacific" :
                            tz == -9 ? "Alaska" : tz == -10 ? "Hawaii-Aleutian" : tz == -11 ? "Samoa" : tz == 10 ? "Chamorro" : "", tz.ToString());
                        ddTimeZone.Add(new ListItem(i.ToString(), i.ToString()));
                    }
                }
                catch (SqlException sqlEx)
                {
                    Tools.LogError(sqlEx, "Error", "SqlException: " + sqlEx.Message, Request);
                }
                catch (Exception ex)
                {
                    Tools.LogError(ex, "Error", "Exception: " + ex.Message, Request);
                }
                finally
                {
                    conn.Close();
                    moveOrgTimeZoneDdl.Items.AddRange(ddTimeZone.ToArray());
                    moveDesTimeZoneDdl.Items.AddRange(ddTimeZone.ToArray());
                }
            }

            // STATE
            if (ddStateUS == null)
                ddStateUS = new List<ListItem>();
            if (ddStateCA == null)
                ddStateCA = new List<ListItem>();
            if (ddStateMX == null)
                ddStateMX = new List<ListItem>();

            using (SqlConnection conn = new SqlConnection(SqlConn2.BOLGenerator))
            {
                try
                {
                    ddStateUS.Add(new ListItem("Select...", ""));
                    ddStateCA.Add(new ListItem("Select...", ""));
                    ddStateMX.Add(new ListItem("Select...", ""));
                    conn.Open();
                    string selectUS = "SELECT * FROM blStates WHERE Country = 'US'";
                    string selectCA = "SELECT * FROM blStates WHERE Country = 'CA'";
                    string selectMX = "SELECT * FROM blStates WHERE Country = 'MX'";
                    SqlCommand UScmd = new SqlCommand(selectUS, conn);
                    SqlCommand CAcmd = new SqlCommand(selectCA, conn);
                    SqlCommand MXcmd = new SqlCommand(selectMX, conn);
                    SqlDataReader USreader = UScmd.ExecuteReader();
                    while (USreader.Read())
                        ddStateUS.Add(new ListItem(USreader.GetString(1).Trim(), USreader.GetString(0).Trim()));

                    USreader.Close();

                    SqlDataReader CAreader = CAcmd.ExecuteReader();
                    while (CAreader.Read())
                        ddStateCA.Add(new ListItem(CAreader.GetString(1).Trim(), CAreader.GetString(0).Trim()));

                    CAreader.Close();

                    SqlDataReader MXreader = MXcmd.ExecuteReader();
                    while (MXreader.Read())
                        ddStateMX.Add(new ListItem(MXreader.GetString(1).Trim(), MXreader.GetString(0).Trim()));

                    MXreader.Close();
                }
                catch (SqlException sqlEx)
                {
                    Tools.LogError(sqlEx, "Error", "SqlException: " + sqlEx.Message, Request);
                }
                catch (Exception ex)
                {
                    Tools.LogError(ex, "Error", "Exception: " + ex.Message, Request);
                }
                finally
                {
                    conn.Close();
                    moveOrgUSStateDdl.Items.AddRange(ddStateUS.ToArray());
                    moveOrgCAStateDdl.Items.AddRange(ddStateCA.ToArray());
                    moveOrgMXStateDdl.Items.AddRange(ddStateMX.ToArray());
                    moveDesUSStateDdl.Items.AddRange(ddStateUS.ToArray());
                    moveDesCAStateDdl.Items.AddRange(ddStateCA.ToArray());
                    moveDesMXStateDdl.Items.AddRange(ddStateMX.ToArray());
                }
            }

            // COUNTRY
            if (ddCountry == null)
                ddCountry = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.BOLGenerator))
            {
                try
                {
                    moveOrgCountryDdl.Items.Add(new ListItem("Select...", ""));
                    moveDesCountryDdl.Items.Add(new ListItem("Select...", ""));

                    conn.Open();
                    string selectStr = "SELECT DISTINCT Country FROM blStates";
                    SqlCommand cmd = new SqlCommand(selectStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    while (reader.Read())
                    {
                        moveOrgCountryDdl.Items.Add(reader.GetString(0));
                        moveDesCountryDdl.Items.Add(reader.GetString(0));
                        if (reader.GetString(0) == "US")
                        {
                            moveOrgCountryDdl.SelectedValue = reader.GetString(0);
                            moveDesCountryDdl.SelectedValue = reader.GetString(0);
                            //newContactCountryDdl.SelectedValue = reader.GetString(0);
                        }
                    }
                }
                catch (SqlException sqlEx)
                {
                    Tools.LogError(sqlEx, "Error", "SqlException: " + sqlEx.Message, Request);
                }
                catch (Exception ex)
                {
                    Tools.LogError(ex, "Error", "Exception: " + ex.Message, Request);
                }
                finally
                {
                    conn.Close();
                }
            }

            //Contacts
            Load_ContactType();

            //LineItens
            Load_Class();
            Load_Client_Type();
            Load_UOM("WEIGHT");
            //Load_UOM("LENGTH");
            //Load_UOM("CUBE");
            Load_UOM("DIM");

            //Reference
            Load_ReferenceTypes();

            //Accessorials
            Load_Accessorials();

        }

        private void Load_Class()
        {
            if (ddClass == null)
                ddClass = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                DataTable dt = new DataTable();
                string selectStr = "SELECT [freightClass] FROM [ShipSystem].[dbo].[blClassLookUp]";
                SqlDataAdapter da = new SqlDataAdapter(selectStr, conn);
                da.Fill(dt);
                foreach (DataRow row in dt.Rows)
                {
                    ddClass.Add(new ListItem(row["freightClass"].ToString(), row["freightClass"].ToString()));
                }
                conn.Close();
            }
        }

        private void Load_Client_Type()
        {
            if (ddType == null)
                ddType = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                DataTable dt = new DataTable();
                string selectStr = "SELECT [PackageType] FROM [ShipSystem].[dbo].[blClientPackageTypes] WHERE [ClientID] = '" + clientID + "' AND [DivisionID] = '" + divID + "' ORDER BY [DefaultType] desc";
                SqlDataAdapter da = new SqlDataAdapter(selectStr, conn);
                da.Fill(dt);
                foreach (DataRow row in dt.Rows)
                {
                    ddType.Add(new ListItem(row["PackageType"].ToString(), row["PackageType"].ToString()));
                }
                conn.Close();
            }
        }

        private void Load_UOM(string p)
        {
            switch (p)
            {
                case "WEIGHT":
                    if (ddWEIGHT == null)
                        ddWEIGHT = new List<ListItem>();
                    break;
                //case "LENGTH":
                //    if (ddLENGTH == null)
                //        ddLENGTH = new List<ListItem>();
                //    break;
                //case "CUBE":
                //    if (ddCUBE == null)
                //        ddCUBE = new List<ListItem>();
                //    break;
                case "DIM":
                    if (ddDIM == null)
                        ddDIM = new List<ListItem>();
                    break;
            }
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                DataTable dt = new DataTable();
                string selectStr = "SELECT [UOM] FROM [ShipSystem].[dbo].[blUOMs] WHERE [UOMCategory] = '" + p + "' ORDER BY [DefaultUOM] DESC";
                SqlDataAdapter da = new SqlDataAdapter(selectStr, conn);
                da.Fill(dt);
                foreach (DataRow row in dt.Rows)
                {
                    ListItem tempval = new ListItem(row["UOM"].ToString(), row["UOM"].ToString());
                    switch (p)
                    {
                        case "WEIGHT":
                            ddWEIGHT.Add(tempval);
                            break;
                        //case "LENGTH":
                        //    ddLENGTH.Add(tempval);
                        //    break;
                        //case "CUBE":
                        //    ddCUBE.Add(tempval);
                        //    break;
                        case "DIM":
                            ddDIM.Add(tempval);
                            break;
                    }
                }
                conn.Close();
            }
        }

        private void Load_ReferenceTypes()
        {
            if (ddReferenceTypes != null)
                return;
            ddReferenceTypes = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                DataTable dt = new DataTable();
                string selectStr = "SELECT [ReferenceType],[DefaultType],[PrintOnBol] FROM [ShipSystem].[dbo].[blClientReferenceTypes] WHERE [ClientID] = '" + clientID + "' AND [DivisionID] = '" + divID + "'";
                SqlDataAdapter da = new SqlDataAdapter(selectStr, conn);
                da.Fill(dt);
                foreach (DataRow row in dt.Rows)
                {
                    ddReferenceTypes.Add(new ListItem(row["ReferenceType"].ToString(), row["ReferenceType"].ToString()));
                    if (row["DefaultType"].ToString() == "1")
                        this.HiddenFieldReferencesRequired.Value += row["ReferenceType"].ToString() + "*";
                }
                int hl = this.HiddenFieldReferencesRequired.Value.ToString().Length;
                if (hl > 0)
                    this.HiddenFieldReferencesRequired.Value = this.HiddenFieldReferencesRequired.Value.ToString().Substring(hl, hl - 1);
                conn.Close();
            }
        }

        private void Load_Accessorials()
        {
            //ACCESSORIALS
            if (ddAccLoc == null)
            {
                ddAccLoc = new List<ListItem>();
                ddAccLoc.Add(new ListItem("Select...", ""));
                ddAccLoc.Add(new ListItem("Origin", "O"));
                ddAccLoc.Add(new ListItem("Destination", "D"));
                ddAccLoc.Add(new ListItem("Always", "A"));
            }

            if (ddAccType == null)
            {
                ddAccType = new List<ListItem>();
                ddAccType.Add(new ListItem("Select...", ""));

                using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
                {
                    conn.Open();
                    DataTable dt = new DataTable();
                    string selectStr = "SELECT [AccCode],[AccDescription] FROM [ShipSystem].[dbo].[blClientAccessorials] WHERE [ClientID] = '" + clientID + "' AND [DivisionID] = '" + divID + "'";
                    SqlDataAdapter da = new SqlDataAdapter(selectStr, conn);
                    da.Fill(dt);
                    foreach (DataRow row in dt.Rows)
                        ddAccType.Add(new ListItem(row["AccDescription"].ToString().Trim(), row["AccCode"].ToString().Trim()));

                    conn.Close();
                }
            }
        }

        private void Load_ContactType()
        {
            if (ddContactType != null)
                return;

            ddContactType = new List<ListItem>();
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                try
                {
                    //editContactTypeDdl.Items.Add(new ListItem("Select...", ""));
                    conn.Open();
                    string selectStr = "SELECT * FROM [ShipSystem].[dbo].[blOrder_ContactType] ORDER BY SelectOrder";
                    SqlCommand cmd = new SqlCommand(selectStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    while (reader.Read())
                    {
                        ddContactType.Add(new ListItem(reader.GetString(0).Trim(), reader.GetString(0).Trim()));
                    }
                }
                catch (SqlException sqlEx)
                {
                    Tools.LogError(sqlEx, "Error", "SqlException: " + sqlEx.Message, Request);
                }
                catch (Exception ex)
                {
                    Tools.LogError(ex, "Error", "Exception: " + ex.Message, Request);
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public List<ddList> Listitem_to_SFddList(List<ListItem> List)
        {
            List<ddList> Result = new List<ddList>();
            if (List != null)
                foreach (ListItem i in List)
                    Result.Add(new ddList(i.Value, i.Text));
            return Result;
        }
        #endregion

        #region Order
        private void Order_to_ItemContent()
        {
            try
            {
                /// Load order details
                refNumberTb.Text = _order.OrderNumber.ToString();  //Reference Number is order number
                shipperNumberTb.Text = _order.ShipperRef;
                salesGroupTb.Text = _order.SalesGroup;
                priEmailTb.Text = _order.PrimaryContactEmail;
                secEmailTb.Text = _order.SecondaryContactEmail;
                supplierIDTb.Text = _order.SupplierID;
                customerIDTb.Text = _order.CustomerID;
                billToTypeDdl.SelectedValue = _order.BillToType;
                methodOfPmtDdl.SelectedValue = _order.MethodOfPayment;
                orderOrgDateTb.Text = _order.OrderOriginationDate.ToShortDateString();
                if (_order.IOType.ToUpper() == "I")
                    IODdl.SelectedIndex = 1;
                else if (_order.IOType.ToUpper() == "O")
                    IODdl.SelectedIndex = 2;
                else
                    IODdl.SelectedIndex = 0;
                planningRuleTb.Text = _order.PlanningRule;
                prefCarrierTb.Text = _order.PreferredCarrier;
                currencyTb.Text = _order.ValuationCurrencyCode;
                orderCommentsTb.Text = _order.Comments;
                orderOnHoldDDL.SelectedIndex = _order.OnHold ? 0 : 1;

                /// Load order Movement details
                moveShipWithRefTb.Text = _order.Movement.ShipWithRef;
                moveLinearFeetTb.Text = _order.Movement.LinearFeet.ToString();
                moveAvailPickupTb.Text = _order.Movement.AvailablePickupDate.ToShortDateString();
                moveReqDeliveryTb.Text = _order.Movement.RequestedDeliveryDate.ToShortDateString();
                moveCodAmtTb.Text = _order.Movement.CodAmount.ToString();
                moveTotalValTb.Text = _order.Movement.TotalValue.ToString();
                moveCodCheckDdl.SelectedIndex = _order.Movement.CodCheck ? 1 : 2;
                moveCodTermsDdl.SelectedIndex = _order.Movement.CodTerms == "c" ? 0 : 1;
                moveCommentsTb.Text = _order.Movement.Comment;

                //Contacts

                //Lineitems

                ///// Load order details to Summary/Save Tab
                //savrefNumberLbl.Text = order.ShipperRef; //Shipment Details
                //savorderOrgDateLbl.Text = order.OrderOriginationDate.ToShortDateString(); //Shipment Details
            }
            catch (Exception ex)
            {
                Tools.LogError(ex, "Error", "Exception: " + ex.Message, Request);
            }
        }

        public void ItemContent_to_Order()
        {

            //Order and Movement
            if (!string.IsNullOrWhiteSpace(refNumberTb.Text))
                _order.OrderNumber = Convert.ToInt32(refNumberTb.Text);//Reference Number is order number

            _order.ClientID = string.IsNullOrWhiteSpace(clientID) ? null : clientID;
            _order.DivisionID = string.IsNullOrWhiteSpace(divID) ? null : divID;
            _order.ShipperRef = string.IsNullOrWhiteSpace(shipperNumberTb.Text) ? null : shipperNumberTb.Text;
            _order.SalesGroup = string.IsNullOrWhiteSpace(salesGroupTb.Text) ? null : salesGroupTb.Text;
            _order.PrimaryContactEmail = string.IsNullOrWhiteSpace(priEmailTb.Text) ? null : priEmailTb.Text;
            _order.SecondaryContactEmail = string.IsNullOrWhiteSpace(secEmailTb.Text) ? null : secEmailTb.Text;
            _order.SupplierID = string.IsNullOrWhiteSpace(supplierIDTb.Text) ? null : supplierIDTb.Text;
            _order.CustomerID = string.IsNullOrWhiteSpace(customerIDTb.Text) ? null : customerIDTb.Text;
            _order.BillToType = string.IsNullOrWhiteSpace(billToTypeDdl.SelectedValue) ? null : billToTypeDdl.SelectedValue;
            _order.MethodOfPayment = string.IsNullOrWhiteSpace(methodOfPmtDdl.SelectedValue) ? null : methodOfPmtDdl.SelectedValue;
            if (!string.IsNullOrWhiteSpace(moveLinearFeetTb.Text))
                _order.OrderOriginationDate = DateTime.Parse(orderOrgDateTb.Text);
            _order.IOType = IODdl.SelectedIndex == 1 ? "I" : "O";
            _order.PlanningRule = string.IsNullOrWhiteSpace(planningRuleTb.Text) ? null : planningRuleTb.Text;
            _order.PreferredCarrier = string.IsNullOrWhiteSpace(prefCarrierTb.Text) ? null : prefCarrierTb.Text;
            _order.ValuationCurrencyCode = string.IsNullOrWhiteSpace(currencyTb.Text) ? null : currencyTb.Text;
            _order.Comments = string.IsNullOrWhiteSpace(orderCommentsTb.Text) ? null : orderCommentsTb.Text;

            /// Load order Movement details
            _order.Movement.MovementID = new Guid(MovementIDHiddenField.Value.ToString());
            _order.Movement.ShipWithRef = string.IsNullOrWhiteSpace(moveShipWithRefTb.Text) ? null : moveShipWithRefTb.Text;

            if (!string.IsNullOrWhiteSpace(moveLinearFeetTb.Text))
                _order.Movement.LinearFeet = Convert.ToInt32(moveLinearFeetTb.Text);
            //_order.Movement.AvailablePickupDate = moveAvailPickupTb.Text;
            //_order.Movement.RequestedDeliveryDate = moveReqDeliveryTb.Text;
            if (!string.IsNullOrWhiteSpace(moveCodAmtTb.Text))
                _order.Movement.CodAmount = Convert.ToDouble(moveCodAmtTb.Text);

            if (!string.IsNullOrWhiteSpace(moveTotalValTb.Text))
                _order.Movement.TotalValue = Convert.ToDouble(moveTotalValTb.Text);
            //_order.Movement.CodCheck = moveCodCheckDdl.SelectedIndex;
            _order.Movement.CodTerms = string.IsNullOrWhiteSpace(moveCodTermsDdl.SelectedValue) ? null : moveCodTermsDdl.SelectedValue;
            _order.Movement.Comment = string.IsNullOrWhiteSpace(moveCommentsTb.Text) ? null : moveCommentsTb.Text;
            _order.Valid = orderHasError.Value == "True" ? true : false;
            _order.OnHold = orderOnHoldDDL.SelectedValue == "True" ? true : false;
            _order.UserID = userID;
        }
        #endregion

        #region Origin
        private void origin_to_ItemContent(OrderMovementAddressClass origin)
        {
            // origin
            if (origin != null)
            {
                MovementOrgAddrIDHiddenField.Value = (origin.AddressID.ToString() != "" ? origin.AddressID.ToString() : "");
                moveOrgLocCodeTb.Text = origin.LocationCode;
                moveOrgNameTb.Text = origin.Name;
                moveOrgAddr1Tb.Text = origin.Address1;
                moveOrgAddr2Tb.Text = origin.Address2;
                moveOrgCityTb.Text = origin.City;
                if (origin.Country == "US")
                {
                    moveOrgUSStateDdl.SelectedValue = origin.State;
                }
                else if (origin.Country == "CA")
                {
                    moveOrgUSStateDdl.CssClass = "contactRowHide";
                    moveOrgCAStateDdl.CssClass = "contactRowShow";
                    moveOrgMXStateDdl.CssClass = "contactRowHide";
                    moveOrgCAStateDdl.SelectedValue = origin.State;
                }
                else if (origin.Country == "MX")
                {
                    moveOrgUSStateDdl.CssClass = "contactRowHide";
                    moveOrgCAStateDdl.CssClass = "contactRowHide";
                    moveOrgMXStateDdl.CssClass = "contactRowShow";
                    moveOrgMXStateDdl.SelectedValue = origin.State;
                }
                moveOrgZipTb.Text = origin.ZipCode;
                moveOrgCountryDdl.SelectedValue = origin.Country;
                if (string.IsNullOrEmpty(origin.Contact))
                    moveOrgContactTb.Text = origin.Contact;
                else
                    moveOrgContactTb.Text = "";
                moveOrgPhoneTb.Text = origin.PhoneNumber;
                moveOrgFaxTb.Text = origin.Fax;
                moveOrgEmailTb.Text = origin.Email;
                moveOrgInstructionsTb.Text = origin.Instructions;
                moveOrgTimeOpenTb.Text = origin.TimeOpen.ToShortTimeString();
                moveOrgTimeCloseTb.Text = origin.TimeClose.ToShortTimeString();

                OrderIDHiddenField.Value = orderID;
            }
        }

        private void ItemContent_to_Origin()
        {
            DateTime openDT, closeDT;

            if (_order.Movement.OrgAddress == null)
                _order.Movement.OrgAddress = new OrderMovementAddressClass();

            //origin
            if (!string.IsNullOrEmpty(MovementOrgAddrIDHiddenField.Value))
                _order.Movement.OrgAddress.AddressID = new Guid(MovementOrgAddrIDHiddenField.Value.ToString());
            else
                _order.Movement.OrgAddress.AddressID = Guid.Empty;
            _order.Movement.OrgAddress.LocationCode = !string.IsNullOrWhiteSpace(moveOrgLocCodeTb.Text) ? moveOrgLocCodeTb.Text : null;
            _order.Movement.OrgAddress.Name = !string.IsNullOrWhiteSpace(moveOrgNameTb.Text) ? moveOrgNameTb.Text : null;
            _order.Movement.OrgAddress.Address1 = !string.IsNullOrWhiteSpace(moveOrgAddr1Tb.Text) ? moveOrgAddr1Tb.Text : null;
            _order.Movement.OrgAddress.Address2 = !string.IsNullOrWhiteSpace(moveOrgAddr2Tb.Text) ? moveOrgAddr2Tb.Text : null;
            _order.Movement.OrgAddress.City = !string.IsNullOrWhiteSpace(moveOrgCityTb.Text) ? moveOrgCityTb.Text : null;
            _order.Movement.OrgAddress.Country = !string.IsNullOrWhiteSpace(moveOrgCountryDdl.SelectedValue) ? moveOrgCountryDdl.SelectedValue : null;
            _order.Movement.OrgAddress.State = !string.IsNullOrWhiteSpace(moveOrgUSStateDdl.SelectedValue) ? moveOrgUSStateDdl.SelectedValue : null;
            _order.Movement.OrgAddress.ZipCode = !string.IsNullOrWhiteSpace(moveOrgZipTb.Text) ? moveOrgZipTb.Text : null;
            _order.Movement.OrgAddress.Country = !string.IsNullOrWhiteSpace(moveOrgCountryDdl.SelectedValue) ? moveOrgCountryDdl.SelectedValue : null;
            _order.Movement.OrgAddress.Contact = !string.IsNullOrEmpty(moveOrgContactTb.Text) ? moveOrgContactTb.Text : null;

            _order.Movement.OrgAddress.PhoneNumber = !string.IsNullOrEmpty(moveOrgPhoneTb.Text) ? moveOrgPhoneTb.Text : null;
            _order.Movement.OrgAddress.Fax = !string.IsNullOrEmpty(moveOrgFaxTb.Text) ? moveOrgFaxTb.Text : null;
            _order.Movement.OrgAddress.Email = !string.IsNullOrEmpty(moveOrgEmailTb.Text) ? moveOrgEmailTb.Text : null;
            _order.Movement.OrgAddress.Instructions = !string.IsNullOrEmpty(moveOrgInstructionsTb.Text) ? moveOrgInstructionsTb.Text : null;
            if (string.IsNullOrEmpty(moveOrgTimeOpenTb.Text))
                _order.Movement.OrgAddress.TimeOpen = new DateTime(1900, 01, 01, 8, 0, 0);
            else
                if (DateTime.TryParse(moveOrgTimeOpenTb.Text, out openDT))
                    _order.Movement.OrgAddress.TimeOpen = openDT;
            if (string.IsNullOrEmpty(moveOrgTimeCloseTb.Text))
                _order.Movement.OrgAddress.TimeClose = new DateTime(1900, 01, 01, 17, 0, 0);
            else
                if (DateTime.TryParse(moveOrgTimeCloseTb.Text, out closeDT))
                    _order.Movement.OrgAddress.TimeClose = closeDT;
        }

        #region Origin DIV
        protected void shipperSearchBtn_Click(object sender, ImageClickEventArgs e)
        {
            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];

            TermsTabClass.AddressFilter filterOn = new TermsTabClass.AddressFilter();
            filterOn.Name = shipperNameSearchTb.Text.Trim();
            filterOn.Code = shipperLocCodeSearchTb.Text.Trim();
            filterOn.City = shipperCitySearchTb.Text.Trim();
            filterOn.State = shipperStateSearchTb.Text.Trim();

            OconsigneeLookupGv.DataSource = termsTab.loadAddressGridView("SHIPPER", OconsigneeLookupGv, filterOn);
            OconsigneeLookupGv.DataBind();
        }

        protected void OconsigneeLookupGv_SelectedIndexChanged(object sender, EventArgs e)
        {
            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];
            if (OconsigneeLookupGv.SelectedIndex > -1)
            {
                // Get the row Guid
                int row = OconsigneeLookupGv.SelectedRow.RowIndex;
                string addressID = OconsigneeLookupGv.DataKeys[row].Value.ToString();
                Guid addressGuid = new Guid(addressID);

                using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
                {
                    conn.Open();

                    string selectStr = "SELECT AddressBookID, CompanyName, LocationCode, ContactName, Address1, Address2, "
                    + "City, State, Zip, Country, PhoneNumber, Email,SpecialInstructions,DefaultOpenTime,DefaultCloseTime "
                    + "FROM blClientAddressBook WHERE AddressBookID = @AddressID ";

                    SqlCommand selectCmd = new SqlCommand(selectStr, conn);
                    selectCmd.Parameters.Add("AddressBookID", SqlDbType.UniqueIdentifier).Value = addressGuid;
                    SqlDataReader reader = selectCmd.ExecuteReader();

                    if (reader.Read())
                    {
                        moveOrgNameTb.Text = reader["CompanyName"].ToString().Trim();
                        moveOrgLocCodeTb.Text = reader["LocationCode"].ToString().Trim();
                        moveOrgContactTb.Text = reader["ContactName"].ToString().Trim();
                        moveOrgAddr1Tb.Text = reader["Address1"].ToString().Trim();
                        moveOrgAddr2Tb.Text = reader["Address2"].ToString().Trim();
                        moveOrgCityTb.Text = reader["City"].ToString().Trim();
                        moveOrgZipTb.Text = reader["Zip"].ToString().Trim();

                        moveOrgUSStateDdl.Attributes.CssStyle.Add("display", "none");
                        moveOrgCAStateDdl.Attributes.CssStyle.Add("display", "none");
                        moveOrgMXStateDdl.Attributes.CssStyle.Add("display", "none");
                        // Set up country so state drop-down will work correctly
                        switch (reader["Country"].ToString().ToUpper().Trim())
                        {
                            case "US":
                                moveOrgCountryDdl.SelectedValue = "US";
                                moveOrgUSStateDdl.Attributes.CssStyle.Add("display", "");
                                moveOrgUSStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;

                            case "CA":
                                moveOrgCountryDdl.SelectedValue = "CA";
                                moveOrgCAStateDdl.Attributes.CssStyle.Add("display", "");

                                moveOrgCAStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;

                            case "MX":
                                moveOrgCountryDdl.SelectedValue = "MX";
                                moveOrgMXStateDdl.Attributes.CssStyle.Add("display", "");

                                moveOrgMXStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;
                        }

                        moveOrgPhoneTb.Text = reader["PhoneNumber"].ToString().Trim();
                        moveOrgEmailTb.Text = reader["Email"].ToString().Trim();

                        moveOrgInstructionsTb.Text = reader["SpecialInstructions"].ToString().Trim();
                        moveOrgTimeOpenTb.Text = Convert.ToDateTime(reader["DefaultOpenTime"].ToString()).ToShortTimeString();
                        moveOrgTimeCloseTb.Text = Convert.ToDateTime(reader["DefaultCloseTime"].ToString()).ToShortTimeString();
                    }
                    reader.Close();
                }
                OriginUpdateHiddenField.Value = (OriginUpdateHiddenField.Value == "false" ? "true" : "false");
            }
        }

        protected void OconsigneeLookupGv_PageIndexChanging(Object sender, GridViewPageEventArgs e)
        {
            OconsigneeLookupGv.PageIndex = e.NewPageIndex;

            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];

            TermsTabClass.AddressFilter filterOn = new TermsTabClass.AddressFilter();
            filterOn.Code = shipperLocCodeSearchTb.Text.Trim();
            filterOn.Name = shipperNameSearchTb.Text.Trim();
            filterOn.City = shipperCitySearchTb.Text.Trim();
            filterOn.State = shipperStateSearchTb.Text.Trim();

            OconsigneeLookupGv.DataSource = termsTab.loadAddressGridView("SHIPPER", OconsigneeLookupGv, filterOn);
            OconsigneeLookupGv.DataBind();
            OconsigneeLookupGv.Attributes.Add("display", "");

        }

        protected void OconsigneeLookupGv_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton selectHyper = (LinkButton)e.Row.Cells[6].Controls[0];
                selectHyper.Attributes.Add("OnClick", "$('#shipperSearchClose').click();");
            }
        }
        #endregion
        #endregion

        #region Destination
        private void destination_to_ItemContent(OrderMovementAddressClass destination)
        {
            // destination
            if (destination != null)
            {
                MovementDesAddrIDHiddenField.Value = (destination.AddressID.ToString() != "" ? destination.AddressID.ToString() : "");
                moveDesLocCodeTb.Text = destination.LocationCode;
                moveDesNameTb.Text = destination.Name;
                moveDesAddr1Tb.Text = destination.Address1;
                moveDesAddr2Tb.Text = destination.Address2;
                moveDesCityTb.Text = destination.City;
                if (destination.Country == "US")
                {
                    moveDesUSStateDdl.SelectedValue = destination.State;
                }
                else if (destination.Country == "CA")
                {
                    moveDesUSStateDdl.CssClass = "contactRowHide";
                    moveDesCAStateDdl.CssClass = "contactRowShow";
                    moveDesMXStateDdl.CssClass = "contactRowHide";
                    moveDesCAStateDdl.SelectedValue = destination.State;
                }
                else if (destination.Country == "MX")
                {
                    moveDesUSStateDdl.CssClass = "contactRowHide";
                    moveDesCAStateDdl.CssClass = "contactRowHide";
                    moveDesMXStateDdl.CssClass = "contactRowShow";
                    moveDesMXStateDdl.SelectedValue = destination.State;
                }
                moveDesZipTb.Text = destination.ZipCode;
                moveDesCountryDdl.SelectedValue = destination.Country;
                if (string.IsNullOrEmpty(destination.Contact))
                    moveDesContactTb.Text = destination.Contact;
                else
                    moveDesContactTb.Text = "";
                moveDesPhoneTb.Text = destination.PhoneNumber;
                moveDesFaxTb.Text = destination.Fax;
                moveDesEmailTb.Text = destination.Email;
                moveDesInstructionsTb.Text = destination.Instructions;
                moveDesTimeOpenTb.Text = destination.TimeOpen.ToShortTimeString();
                moveDesTimeCloseTb.Text = destination.TimeClose.ToShortTimeString();

                //moveDesTimeZoneDdl.SelectedValue = destination.Timezone;
                OrderIDHiddenField.Value = orderID;
            }
        }

        private void ItemContent_to_Destination()
        {
            DateTime openDT, closeDT;
            if (_order.Movement.DesAddress == null)
                _order.Movement.DesAddress = new OrderMovementAddressClass();

            //destination
            if (!string.IsNullOrEmpty(MovementDesAddrIDHiddenField.Value))
                _order.Movement.DesAddress.AddressID = new Guid(MovementDesAddrIDHiddenField.Value.ToString());
            else
                _order.Movement.DesAddress.AddressID = Guid.Empty;
            _order.Movement.DesAddress.LocationCode = !string.IsNullOrWhiteSpace(moveDesLocCodeTb.Text) ? moveDesLocCodeTb.Text : null;
            _order.Movement.DesAddress.Name = !string.IsNullOrWhiteSpace(moveDesNameTb.Text) ? moveDesNameTb.Text : null;
            _order.Movement.DesAddress.Address1 = !string.IsNullOrWhiteSpace(moveDesAddr1Tb.Text) ? moveDesAddr1Tb.Text : null;
            _order.Movement.DesAddress.Address2 = !string.IsNullOrWhiteSpace(moveDesAddr2Tb.Text) ? moveDesAddr2Tb.Text : null;
            _order.Movement.DesAddress.City = !string.IsNullOrWhiteSpace(moveDesCityTb.Text) ? moveDesCityTb.Text : null;
            _order.Movement.DesAddress.Country = !string.IsNullOrWhiteSpace(moveDesCountryDdl.SelectedValue) ? moveDesCountryDdl.SelectedValue : null;
            _order.Movement.DesAddress.State = !string.IsNullOrWhiteSpace(moveDesUSStateDdl.SelectedValue) ? moveDesUSStateDdl.SelectedValue : null;
            _order.Movement.DesAddress.ZipCode = !string.IsNullOrWhiteSpace(moveDesZipTb.Text) ? moveDesZipTb.Text : null;
            _order.Movement.DesAddress.Country = !string.IsNullOrWhiteSpace(moveDesCountryDdl.SelectedValue) ? moveDesCountryDdl.SelectedValue : null;
            _order.Movement.DesAddress.Contact = !string.IsNullOrEmpty(moveDesContactTb.Text) ? moveDesContactTb.Text : null;

            _order.Movement.DesAddress.PhoneNumber = !string.IsNullOrEmpty(moveDesPhoneTb.Text) ? moveDesPhoneTb.Text : null;
            _order.Movement.DesAddress.Fax = !string.IsNullOrEmpty(moveDesFaxTb.Text) ? moveDesFaxTb.Text : null;
            _order.Movement.DesAddress.Email = !string.IsNullOrEmpty(moveDesEmailTb.Text) ? moveDesEmailTb.Text : null;
            _order.Movement.DesAddress.Instructions = !string.IsNullOrEmpty(moveDesInstructionsTb.Text) ? moveDesInstructionsTb.Text : null;
            if (string.IsNullOrEmpty(moveDesTimeOpenTb.Text))
                _order.Movement.DesAddress.TimeOpen = new DateTime(1900, 01, 01, 8, 0, 0);
            else
                if (DateTime.TryParse(moveDesTimeOpenTb.Text, out openDT))
                    _order.Movement.DesAddress.TimeOpen = openDT;
            if (string.IsNullOrEmpty(moveDesTimeCloseTb.Text))
                _order.Movement.DesAddress.TimeClose = new DateTime(1900, 01, 01, 17, 0, 0);
            else
                if (DateTime.TryParse(moveDesTimeCloseTb.Text, out closeDT))
                    _order.Movement.DesAddress.TimeClose = closeDT;
        }

        #region Destination DIV
        protected void DconsigneeLookupGv_SelectedIndexChanged(object sender, EventArgs e)
        {
            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];
            if (DconsigneeLookupGv.SelectedIndex > -1)
            {
                int row = DconsigneeLookupGv.SelectedRow.RowIndex;
                string addressID = DconsigneeLookupGv.DataKeys[row].Value.ToString();
                Guid addressGuid = new Guid(addressID);

                using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
                {
                    conn.Open();

                    string selectStr = "SELECT AddressBookID, CompanyName, LocationCode, ContactName, Address1, Address2, "
                    + "City, State, Zip, Country, PhoneNumber, Email, SpecialInstructions,DefaultOpenTime,DefaultCloseTime "
                    + "FROM blClientAddressBook WHERE AddressBookID = @AddressID ";

                    SqlCommand selectCmd = new SqlCommand(selectStr, conn);
                    selectCmd.Parameters.Add("@AddressID", SqlDbType.UniqueIdentifier).Value = addressGuid;
                    SqlDataReader reader = selectCmd.ExecuteReader();

                    if (reader.Read())
                    {
                        moveDesLocCodeTb.Text = reader["LocationCode"].ToString().Trim();
                        moveDesNameTb.Text = reader["CompanyName"].ToString().Trim();
                        moveDesContactTb.Text = reader["ContactName"].ToString().Trim();
                        moveDesAddr1Tb.Text = reader["Address1"].ToString().Trim();
                        moveDesAddr2Tb.Text = reader["Address2"].ToString().Trim();
                        moveDesCityTb.Text = reader["City"].ToString().Trim();
                        moveDesZipTb.Text = reader["Zip"].ToString().Trim();

                        // Set up country so state drop-down will work correctly
                        switch (reader["Country"].ToString().ToUpper().Trim())
                        {
                            case "US":
                                moveDesCountryDdl.SelectedValue = "US";
                                moveDesUSStateDdl.Attributes.CssStyle.Add("display", "");
                                moveDesCAStateDdl.Attributes.CssStyle.Add("display", "none");
                                moveDesMXStateDdl.Attributes.CssStyle.Add("display", "none");

                                moveDesUSStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;

                            case "CA":
                                moveDesCountryDdl.SelectedValue = "CA";
                                moveDesUSStateDdl.Attributes.CssStyle.Add("display", "none");
                                moveDesCAStateDdl.Attributes.CssStyle.Add("display", "");
                                moveDesMXStateDdl.Attributes.CssStyle.Add("display", "none");

                                moveDesCAStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;

                            case "MX":
                                moveDesCountryDdl.SelectedValue = "MX";
                                moveDesUSStateDdl.Attributes.CssStyle.Add("display", "none");
                                moveDesCAStateDdl.Attributes.CssStyle.Add("display", "none");
                                moveDesMXStateDdl.Attributes.CssStyle.Add("display", "");

                                moveDesMXStateDdl.SelectedValue = reader["State"].ToString().Trim();
                                break;
                        }
                        moveDesPhoneTb.Text = reader["PhoneNumber"].ToString().Trim();
                        moveDesEmailTb.Text = reader["Email"].ToString().Trim();
                        moveDesInstructionsTb.Text = reader["SpecialInstructions"].ToString().Trim();
                        moveDesTimeOpenTb.Text = Convert.ToDateTime(reader["DefaultOpenTime"].ToString()).ToShortTimeString();
                        moveDesTimeCloseTb.Text = Convert.ToDateTime(reader["DefaultCloseTime"].ToString()).ToShortTimeString();
                    }
                    reader.Close();
                    DestinationUpdateHiddenField.Value = (DestinationUpdateHiddenField.Value == "false" ? "true" : "false");
                }
            }
        }

        protected void DconsigneeLookupGv_PageIndexChanging(Object sender, GridViewPageEventArgs e)
        {
            DconsigneeLookupGv.PageIndex = e.NewPageIndex;

            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];

            TermsTabClass.AddressFilter filterOn = new TermsTabClass.AddressFilter();
            filterOn.Code = DconsigneeLocCodeSearchTb.Text.Trim();
            filterOn.Name = DconsigneeNameSearchTb.Text.Trim();
            filterOn.City = DconsigneeCitySearchTb.Text.Trim();
            filterOn.State = DconsigneeStateSearchTb.Text.Trim();

            DconsigneeLookupGv.DataSource = termsTab.loadAddressGridView("CONSIGNEE", DconsigneeLookupGv, filterOn);
            DconsigneeLookupGv.DataBind();
            DconsigneeLookupGv.Attributes.Add("display", "");
        }

        protected void DconsigneeLookupGv_RowCreated(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                LinkButton selectHyper = (LinkButton)e.Row.Cells[6].Controls[0];
                selectHyper.Attributes.Add("OnClick", "$('#consigneeSearchClose').click();");
            }
        }

        protected void DconsigneeSearchBtn_Click(object sender, ImageClickEventArgs e)
        {
            TermsTabClass termsTab = (TermsTabClass)Session["TermsTab"];

            TermsTabClass.AddressFilter filterOn = new TermsTabClass.AddressFilter();
            filterOn.Name = DconsigneeNameSearchTb.Text.Trim();
            filterOn.Code = DconsigneeLocCodeSearchTb.Text.Trim();
            filterOn.City = DconsigneeCitySearchTb.Text.Trim();
            filterOn.State = DconsigneeStateSearchTb.Text.Trim();

            DconsigneeLookupGv.DataSource = termsTab.loadAddressGridView("CONSIGNEE", DconsigneeLookupGv, filterOn);
            DconsigneeLookupGv.DataBind();
        }
        #endregion
        #endregion

        #region Contacts
        private void Contacts_to_ItemContent(List<OrderContactClass> list)
        {
            //Initial load of data
            Load_ContactType();
            if (ddStateUS == null)
                loadDropDowns();

            Session["CDataSource"] = list;
            this.ContactsGrid.DataSource = list;

            var index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "ContactTypeList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddContactType);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateUSList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateUS);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateCAList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateCA);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateMXList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateMX);

            this.ContactsGrid.DataBind();
            C_Validate(list);
        }

        public bool addContact(OrderContactClass contact)
        {
            bool result = true;

            if (Session["CDataSource"] != null)
            {
                //Loaded to session
                List<OrderContactClass> data = Session["CDataSource"] as List<OrderContactClass>;
                data.Insert(data.Count(), contact);
                Session["CDataSource"] = data;
            }
            return result;
        }

        protected void C_EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            C_EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void C_EditAction(string eventType, object record)
        {
            OrderContactClass value = new OrderContactClass();
            List<OrderContactClass> data = Session["CDataSource"] as List<OrderContactClass>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            foreach (KeyValuePair<string, object> keyval in KeyVal)
            {
                if (keyval.Key == "ContactID")
                {
                    if ((eventType == "endEdit") || (eventType == "endDelete"))
                    {
                        value = data.Where(d => d.ContactID.ToString() == keyval.Value.ToString() && d.Action != "D").FirstOrDefault();
                        value.ContactID = new Guid(keyval.Value.ToString());

                        if (eventType == "endDelete")
                            value.Action = "D";
                        else if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "U";
                    }
                    else
                    {
                        value.ContactID = Guid.Empty;
                        if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "A";
                    }

                    this.OrderModifiedHiddenField.Value = "true";
                }
                else if (keyval.Key == "CompanyName")
                    value.CompanyName = Convert.ToString(keyval.Value);
                else if (keyval.Key == "ContactType")
                    value.ContactType = Convert.ToString(keyval.Value);
                else if (keyval.Key == "ContactName")
                    value.ContactName = Convert.ToString(keyval.Value);
                else if (keyval.Key == "CompanyName")
                    value.CompanyName = Convert.ToString(keyval.Value);
                else if (keyval.Key == "CompanyName")
                    value.CompanyName = Convert.ToString(keyval.Value);
                else if (keyval.Key == "CompanyName")
                    value.CompanyName = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Address1")
                    value.Address1 = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Address2")
                    value.Address2 = Convert.ToString(keyval.Value);
                else if (keyval.Key == "City")
                    value.City = Convert.ToString(keyval.Value);
                else if (keyval.Key == "State")
                    value.State = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Zip")
                    value.Zip = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PhoneNumber")
                    value.PhoneNumber = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PhoneExt")
                    value.PhoneExt = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PhoneMobile")
                    value.PhoneMobile = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Fax")
                    value.Fax = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Email")
                    value.Email = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Scac")
                    value.Scac = Convert.ToString(keyval.Value);
            }

            if (eventType == "endAdd")
                data.Insert(0, value);

            Load_ContactType();
            if (ddStateUS == null)
                loadDropDowns();

            Session["CDataSource"] = data;
            this.ContactsGrid.DataSource = C_ListofnotDeleted(data);
            var index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "ContactTypeList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddContactType);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateUSList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateUS);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateCAList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateCA);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateMXList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateMX);

            this.ContactsGrid.DataBind();
            //this.ContactsUpdateHiddenField.Value = (this.ContactsUpdateHiddenField.Value == "false" ? "true" : "false");
            C_Validate(data);
        }

        private string C_SaveData()
        {
            string Result = "";
            bool result = true;
            string errStr = "";

            //Contacts
            List<OrderContactClass> data = Session["CDataSource"] as List<OrderContactClass>;
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                foreach (OrderContactClass item in data)
                {
                    if (!string.IsNullOrWhiteSpace(item.Action))
                    {
                        result = OrderContactClass.sortActions(conn, item, this.OrderIDHiddenField.Value, out errStr);
                        if (!result)
                        {
                            //this.ContactsUpdateHiddenField.Value = "true";
                            this.ContactsLabel.Text = errStr;
                            Result = " Contacts: " + errStr;
                            break;
                        }
                        else
                        {
                            if (item.Action != "D")
                                item.Action = "";
                        }
                    }
                }
                conn.Close();
                data.RemoveAll(x => x.Action == "D"); //removes from the list
            }

            Load_ContactType();
            if (ddStateUS == null)
                loadDropDowns();

            Session["CDataSource"] = data;
            this.ContactsGrid.DataSource = C_ListofnotDeleted(data);
            var index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "ContactTypeList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddContactType);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateUSList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateUS);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateCAList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateCA);
            index = this.ContactsGrid.Columns.FindIndex(col => col.Field == "StateMXList");
            this.ContactsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddStateMX);

            this.ContactsGrid.DataBind();
            //this.ContactsUpdateHiddenField.Value = (this.ContactsUpdateHiddenField.Value == "false" ? "true" : "false");
            C_Validate(data);
            return Result;
        }

        private void C_Validate(List<OrderContactClass> list)
        {
            bool Result = true;
            bool found = false;
            string errorstr = "";

            foreach (OrderContactClass item in list)
            {
                //validation on address
            }

            if (!Result)
                this.ContactsHasError.Value = "true";
            else
                this.ContactsHasError.Value = "false";

            ContactsLabel.Text = "Contacts : " + (errorstr.Length > 0 ? errorstr : list.Count.ToString() + " Contacts");
        }

        private List<OrderContactClass> C_ListofnotDeleted(List<OrderContactClass> data)
        {
            if (data.Count(x => x.Action == "D") > 0)
            {
                List<OrderContactClass> tlist = new List<OrderContactClass>();
                foreach (OrderContactClass a in data)
                    if (a.Action != "D") tlist.Add(a);
                return tlist;
            }
            else
                return data;
        }
        #endregion

        #region LineItems
        private void LineItems_to_ItemContent(List<OrderLineItemClass> list)
        {
            //Initial load of data
            Load_Class();
            Load_Client_Type();
            Load_UOM("WEIGHT");
            //Load_UOM("LENGTH");
            //Load_UOM("CUBE");
            Load_UOM("DIM");

            Session["LIDataSource"] = list;
            LineItemGrid.DataSource = list;

            var index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "ClassDD");
            this.LineItemGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddClass);

            index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "TypeDD");
            this.LineItemGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddType);

            index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "WeightDD");
            this.LineItemGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddWEIGHT);

            //index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "LengthDD");
            //this.LineItemGrid.Columns.ElementAt(index).DataSource = ddLENGTH;

            //index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "CubeDD");
            //this.LineItemGrid.Columns.ElementAt(index).DataSource = ddCUBE;

            index = this.LineItemGrid.Columns.FindIndex(col => col.Field == "DimDD");
            this.LineItemGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddDIM);

            LineItemGrid.DataBind();
            LI_Validate(list);
        }
        protected void LI_EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            LI_EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void LI_EditAction(string eventType, object record)
        {
            OrderLineItemClass value = new OrderLineItemClass();
            List<OrderLineItemClass> data = Session["LIDataSource"] as List<OrderLineItemClass>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            foreach (KeyValuePair<string, object> keyval in KeyVal)
            {
                if (keyval.Key == "LineItemID")
                {
                    if ((eventType == "endEdit") || (eventType == "endDelete"))
                    {
                        value = data.Where(d => d.LineitemID.ToString() == keyval.Value.ToString() && d.Action != "D").FirstOrDefault();
                        value.LineitemID = new Guid(keyval.Value.ToString());
                        if (eventType == "endDelete")
                            value.Action = "D";
                        else if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "U";
                    }
                    else
                    {
                        value.LineitemID = Guid.Empty;
                        if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "A";
                    }

                    this.OrderModifiedHiddenField.Value = "true";
                }
                else if (keyval.Key == "ProductID")
                    value.ProductID = Convert.ToString(keyval.Value);
                else if (keyval.Key == "ProductSKU")
                    value.ProductSKU = Convert.ToString(keyval.Value);
                else if (keyval.Key == "CommodityDescription")
                    value.CommodityDescription = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PackageQuantity")
                    value.PackageQuantity = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "PackageWeight")
                    value.PackageWeight = Convert.ToDouble(keyval.Value);
                else if (keyval.Key == "PackageWeightUOM")
                    value.PackageWeightUOM = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PackageType")
                    value.PackageType = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PackageQuantityPerUnitLoad")
                    value.PackageQuantityPerUnitLoad = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "Class")
                    value.Class = Convert.ToString(keyval.Value);
                else if (keyval.Key == "NMFC")
                    value.NMFC = Convert.ToString(keyval.Value);
                else if (keyval.Key == "FoodStr")
                    value.Food = Convert.ToString(keyval.Value) == "Yes" ? true : false;
                else if (keyval.Key == "Food")
                    value.Food = Convert.ToBoolean(keyval.Value);
                else if (keyval.Key == "FreezableStr")
                    value.Freezable = Convert.ToString(keyval.Value) == "Yes" ? true : false;
                else if (keyval.Key == "Freezable")
                    value.Freezable = Convert.ToBoolean(keyval.Value);
                else if (keyval.Key == "Description")
                    value.Description = Convert.ToString(keyval.Value);
                else if ((keyval.Key == "LadingQuantity") && (Convert.ToString(keyval.Value) != ""))
                    value.LadingQuantity = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "NetWeight")
                    value.NetWeight = ((keyval.Value.ToString() == "") ? 0 : Convert.ToDouble(keyval.Value));
                else if (keyval.Key == "NetWeightUOM")
                    value.NetWeightUOM = Convert.ToString(keyval.Value);
                else if ((keyval.Key == "ValuationRate") && (Convert.ToString(keyval.Value) != ""))
                    value.ValuationRate = Convert.ToInt32(keyval.Value);
                else if ((keyval.Key == "ValuationTotal") && (Convert.ToString(keyval.Value) != ""))
                    value.ValuationTotal = Convert.ToDouble(keyval.Value);
                else if (keyval.Key == "HazardStr")
                    value.Hazard = Convert.ToString(keyval.Value) == "Yes" ? true : false;
                else if (keyval.Key == "isHazmat")
                    value.Hazard = Convert.ToString(keyval.Value) == "Yes" ? true : false;
                else if (keyval.Key == "hazUNNumber")
                    value.hazUNNumber = Convert.ToString(keyval.Value);
                else if (keyval.Key == "hazardClass")
                    value.hazClass = Convert.ToString(keyval.Value);
                else if (keyval.Key == "hazPackageGroup")
                    value.hazPackageGroup = Convert.ToString(keyval.Value);
                else if (keyval.Key == "hazAdditionalText")
                    value.hazAdditionalText = Convert.ToString(keyval.Value);
                else if (keyval.Key == "hazDoReportQuantity")
                    value.hazDoReportQuantity = Convert.ToString(keyval.Value) == "Yes" ? true : false;
                else if (keyval.Key == "Action")
                    value.Action = Convert.ToString(keyval.Value);
                else if (keyval.Key == "PackageLength")
                    value.PackageLength = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "PackageWidth")
                    value.PackageWidth = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "PackageHight")
                    value.PackageHeight = Convert.ToInt32(keyval.Value);
                else if (keyval.Key == "PackageDimUOM")
                    value.PackageDimUOM = Convert.ToString(keyval.Value);
                else if (keyval.Key == "Poisonous")
                    value.Poisonous = Convert.ToBoolean(keyval.Value);
            }

            if (eventType == "endAdd")
                data.Add(value);

            LineItems_to_ItemContent(data);
            LI_Validate(data);
            
            //LineItemsUpdateHiddenField.Value = (LineItemsUpdateHiddenField.Value == "false" ? "true" : "false");
        }  //end EditAction

        private string LI_SaveData()
        {
            string Result = "";
            bool result;
            string errStr;

            //LineItems
            List<OrderLineItemClass> data = Session["LIDataSource"] as List<OrderLineItemClass>;
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                foreach (OrderLineItemClass li in data)
                {
                    if (!string.IsNullOrWhiteSpace(li.Action))
                    {
                        li.MovementID = new Guid(this.MovementIDHiddenField.Value.ToString());
                        result = OrderLineItemClass.sortActions(conn, li, this.OrderIDHiddenField.Value, out errStr);
                        if (!result)
                        {
                            this.lineitemHasError.Value = "true";
                            this.LineItemsLabel.Text = errStr;
                            Result = " Line Items: " + errStr;
                            break;
                        }
                        else
                        {
                            if (li.Action != "D")
                                li.Action = "";
                        }
                    }
                }
                conn.Close();
                data.RemoveAll(x => x.Action == "D"); //removes from the list
            }

            LineItems_to_ItemContent(data);
            LI_Validate(data);
            return Result;
        }

        private void LI_Validate(List<OrderLineItemClass> list)
        {
            bool Result = true;
            bool found = false;
            string errorstr = "";

            if (list.Count < 1)
            {
                Result = false;
                errorstr = " No Products are set to ship ";
            }

            if (!Result)
                this.lineitemHasError.Value = "true";
            else
                this.lineitemHasError.Value = "false";

            LineItemsLabel.Text = "Line Items : " + (errorstr.Length > 0 ? errorstr : list.Count.ToString() + " Line Items ");
        }

        private List<OrderLineItemClass> L_ListofnotDeleted(List<OrderLineItemClass> data)
        {
            if (data.Count(x => x.Action == "D") > 0)
            {
                List<OrderLineItemClass> tlist = new List<OrderLineItemClass>();
                foreach (OrderLineItemClass a in data)
                    if (a.Action != "D") tlist.Add(a);
                return tlist;
            }
            else
                return data;
        }
        #endregion

        #region References
        private void References_to_ItemContent(List<OrderReferenceClass> list)
        {
            Load_ReferenceTypes();
            Session["RDataSource"] = list;
            this.ReferencesGrid.DataSource = list;
            var index = this.ReferencesGrid.Columns.FindIndex(col => col.Field == "ReferenceType");
            this.ReferencesGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddReferenceTypes);
            this.ReferencesGrid.DataBind();
            R_Validate(list);
        }

        protected void R_EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            R_EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void R_EditAction(string eventType, object record)
        {
            OrderReferenceClass value = new OrderReferenceClass();
            List<OrderReferenceClass> data = Session["RDataSource"] as List<OrderReferenceClass>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            foreach (KeyValuePair<string, object> keyval in KeyVal)
            {
                if (keyval.Key == "ReferenceID")
                {
                    if ((eventType == "endEdit") || (eventType == "endDelete"))
                    {
                        value = data.Where(d => d.ReferenceID.ToString() == keyval.Value.ToString()).FirstOrDefault();
                        value.ReferenceID = new Guid(keyval.Value.ToString());

                        if (eventType == "endDelete")
                            value.Action = "D";
                        else if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "U";
                    }
                    else
                    {
                        value.ReferenceID = Guid.Empty;
                        if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "A";
                    }

                    this.OrderModifiedHiddenField.Value = "true";
                }
                else if (keyval.Key == "ReferenceType")
                    value.ReferenceType = Convert.ToString(keyval.Value);
                else if (keyval.Key == "ReferenceValue")
                    value.ReferenceValue = Convert.ToString(keyval.Value);
                else if (keyval.Key == "ReferencePrint")
                    value.ReferencePrint = Convert.ToString(keyval.Value) == "Yes" ? true : false;
            }

            if (eventType == "endAdd")
                data.Insert(0, value);

            Load_ReferenceTypes();

            Session["RDataSource"] = data;
            this.ReferencesGrid.DataSource = R_ListofnotDeleted(data);
            var index = this.ReferencesGrid.Columns.FindIndex(col => col.Field == "ReferenceType");
            this.ReferencesGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddReferenceTypes);
            this.ReferencesGrid.DataBind();
            //this.ReferencesUpdateHiddenField.Value = (this.ReferencesUpdateHiddenField.Value == "false" ? "true" : "false");
            R_Validate(data);
            UpdatePanelReferences.Update();
        }

        private string R_SaveData()
        {
            string Result = "";
            bool result;
            string errStr;

            //Reference
            List<OrderReferenceClass> data = Session["RDataSource"] as List<OrderReferenceClass>;
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                foreach (OrderReferenceClass item in data)
                {
                    if (!string.IsNullOrWhiteSpace(item.Action))
                    {
                        result = OrderReferenceClass.sortActions(conn, item, this.OrderIDHiddenField.Value, out errStr);
                        if (!result)
                        {
                            //this.ReferencesUpdateHiddenField.Value = "true";
                            this.ReferencesLabel.Text = errStr;
                            Result = " References: " + errStr;
                            break;
                        }
                        else
                        {
                            if (item.Action != "D")
                                item.Action = "";
                        }
                    }
                }
                conn.Close();
                data.RemoveAll(x => x.Action == "D"); //removes from the list
            }

            Load_ReferenceTypes();

            Session["RDataSource"] = data;
            this.ReferencesGrid.DataSource = R_ListofnotDeleted(data);
            var index = this.ReferencesGrid.Columns.FindIndex(col => col.Field == "ReferenceType");
            this.ReferencesGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddReferenceTypes);
            this.ReferencesGrid.DataBind();
            //this.ReferencesUpdateHiddenField.Value = (this.ReferencesUpdateHiddenField.Value == "false" ? "true" : "false");
            R_Validate(data);
            return Result;
        }

        private void R_Validate(List<OrderReferenceClass> list)
        {
            bool Result = true;
            bool found = false;
            string errorstr = "";
            if (this.HiddenFieldReferencesRequired.Value.Length > 1)
            {
                string[] req = this.HiddenFieldReferencesRequired.Value.ToString().Split('*');

                foreach (string sought in req)
                {
                    found = false;
                    foreach (OrderReferenceClass item in list)
                    {
                        if (sought == item.ReferenceType)
                        {
                            found = true;
                            break;
                        }

                        if (item.ReferenceValue.Length < 1)
                        {
                            Result = false;
                            errorstr += " Refrence " + item.ReferenceType + " is missing a value. ";
                        }

                    }

                    if (!found)
                    {
                        Result = false;
                        errorstr += " required Refrence " + sought.Trim() + " was not found. ";
                    }
                }
            }

            if (!Result)
                this.ReferencesHasError.Value = "true";
            else
                this.ReferencesHasError.Value = "false";

            ReferencesLabel.Text = "References: " + (errorstr.Length > 0 ? errorstr : list.Count.ToString() + " References");
        }

        private List<OrderReferenceClass> R_ListofnotDeleted(List<OrderReferenceClass> data)
        {
            if (data.Count(x => x.Action == "D") > 0)
            {
                List<OrderReferenceClass> tlist = new List<OrderReferenceClass>();
                foreach (OrderReferenceClass a in data)
                    if (a.Action != "D") tlist.Add(a);
                return tlist;
            }
            else
                return data;
        }
        #endregion

        #region Accessorials
        private void Accessorials_to_ItemContent(List<OrderAccessorialClass> list)
        {
            //Initial load of data
            Load_Accessorials();
            Session["ADataSource"] = list;  //data;
            this.AccessorialsGrid.DataSource = list;  //data;

            var index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "AccType");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccType);
            index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "OrgDesAlways");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccLoc);

            this.AccessorialsGrid.DataBind();
            A_Validate(list);
        }

        protected void A_EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            A_EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void A_EditAction(string eventType, object record)
        {
            OrderAccessorialClass value = new OrderAccessorialClass();
            List<OrderAccessorialClass> data = Session["ADataSource"] as List<OrderAccessorialClass>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;

            foreach (KeyValuePair<string, object> keyval in KeyVal)
            {
                if (keyval.Key == "AccessorialID")
                {
                    if ((eventType == "endEdit") || (eventType == "endDelete"))
                    {
                        value = data.Where(d => d.AccessorialID.ToString() == keyval.Value.ToString() && d.Action != "D").FirstOrDefault();
                        value.AccessorialID = new Guid(keyval.Value.ToString());

                        if (eventType == "endDelete")
                            value.Action = "D";
                        else if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "U";
                    }
                    else
                    {
                        value.AccessorialID = Guid.Empty;
                        if (string.IsNullOrWhiteSpace(value.Action))
                            value.Action = "A";
                    }

                    this.OrderModifiedHiddenField.Value = "true";
                }
                else if (keyval.Key == "AccType")
                    value.AccType = Convert.ToString(keyval.Value);
                else if (keyval.Key == "OrgDesAlways")
                    value.OrgDesAlways = Convert.ToString(keyval.Value);
            }

            if (eventType == "endAdd")
                data.Insert(0, value);

            Load_Accessorials();

            Session["ADataSource"] = data;
            this.AccessorialsGrid.DataSource = A_ListofnotDeleted(data);
            var index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "AccType");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccType);
            index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "OrgDesAlways");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccLoc);

            this.AccessorialsGrid.DataBind();
            //A_UpdateHiddenField.Value = (A_UpdateHiddenField.Value == "false" ? "true" : "false");
            A_Validate(data);
        }

        private string A_SaveData()
        {
            string Result = "";
            bool result;
            string errStr;

            //Accessorial
            List<OrderAccessorialClass> data = Session["ADataSource"] as List<OrderAccessorialClass>;
            using (SqlConnection conn = new SqlConnection(SqlConn2.ShipSystem))
            {
                conn.Open();
                foreach (OrderAccessorialClass i in data)
                {
                    if (!string.IsNullOrWhiteSpace(i.Action))
                    {
                        result = OrderAccessorialClass.sortActions(conn, i, this.OrderIDHiddenField.Value, out errStr);
                        if (!result)
                        {
                            this.AccessorialsHasError.Value = "true";
                            this.AccessorialsLabel.Text = errStr;
                            Result = " Accessorial: " + errStr;
                            break;
                        }
                        else
                        {
                            if (i.Action != "D")
                                i.Action = "";
                        }
                    }
                }
                conn.Close();
                data.RemoveAll(x => x.Action == "D"); //removes from the list
            }

            Load_Accessorials();

            Session["ADataSource"] = data;
            this.AccessorialsGrid.DataSource = data;  // this one is clean
            var index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "AccType");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccType);
            index = this.AccessorialsGrid.Columns.FindIndex(col => col.Field == "OrgDesAlways");
            this.AccessorialsGrid.Columns.ElementAt(index).DataSource = Listitem_to_SFddList(ddAccLoc);

            this.AccessorialsGrid.DataBind();
            //A_UpdateHiddenField.Value = (A_UpdateHiddenField.Value == "false" ? "true" : "false");
            A_Validate(data);
            return Result;
        }


        private void A_Validate(List<OrderAccessorialClass> data)
        {
            //bool Result = true;
            //bool found = false;
            //string errorstr = null;

            //if (!Result)
            //    this.AccessorialsHasError.Value = "true";
            //else
            AccessorialsLabel.Text = data.Count.ToString() + " Accessorials";
        }

        private List<OrderAccessorialClass> A_ListofnotDeleted(List<OrderAccessorialClass> data)
        {
            if (data.Count(x => x.Action == "D") > 0)
            {
                List<OrderAccessorialClass> tlist = new List<OrderAccessorialClass>();
                foreach (OrderAccessorialClass a in data)
                    if (a.Action != "D") tlist.Add(a);
                return tlist;
            }
            else
                return data;
        }
        #endregion
    }
}